/**********************************************************************
Copyright (C) 1998-2000 by OpenEye Scientific Software, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
***********************************************************************/

#include <map>

#include "mol.h"
#include "rotor.h"

namespace OpenEye 
{

class OERotamerList
{
  vector<float*> _c;
  vector<vector<float> > _vres;
  vector<unsigned char*> _vrotamer;
  vector<pair<OEAtom**,vector<int> > > _vrotor;
public:
  ~OERotamerList();
  void Setup(OEMol&,OERotorList&);
  void Setup(OEMol&,unsigned char*,int);
  int NumRotors() {return((_vrotor.empty())?0:_vrotor.size());}
  int NumRotamers() {return((_vrotamer.empty())?0:_vrotamer.size());}
  void AddRotamer(float*);
  void AddRotamer(int *arr);
  void AddRotamer(unsigned char *arr);
  void AddRotamers(unsigned char*,int);
  void GetReferenceArray(unsigned char*);
  void ExpandConformerList(OEMol&,vector<float*>&);
  vector<unsigned char*>::iterator BeginRotamer() {return(_vrotamer.begin());}
  vector<unsigned char*>::iterator EndRotamer() {return(_vrotamer.end());}
};

class OEBinaryDBase
{
  ifstream _ifs;
  vector<streampos> _vpos;
 public:
  OEBinaryDBase(char*);
  OEBinaryDBase(string&);
  int  Size();
  void GetMolecule(OEMol&,int);
};

int Swab(int);
}
