// MM2MDL.H : data storage for reduced protein models (molecular mechanics).

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

/*################################################################################################*/

#include "config.h"	// this is target-dependent...

#ifndef MM2MDL_H
#define MM2MDL_H

class mm2_mdl;

/*################################################################################################*/

class mm1_mdl;		// mm1mdl.h

#include "model.h"
#include "mm2util.h"
#include "mm1util.h"

#include <vector>

/*################################################################################################*/

class mm2_mdl : public model_extended
{
	protected:
	
	vector<mm2_chn> chn_vector;
	vector<mm2_dsb> dsb_vector;
	
	friend class mm2_ribbon;
		
	public:
	
	mm2_mdl(ostream *, err_util_factory &, void *);
	~mm2_mdl(void);
	
	const char * GetProjectFileNameExtension(void);		// virtual
	
	bool ReadStream(istream &);	// virtual
	void WriteStream(ostream &);	// virtual
	
	void PushCRDSets(i32u);			// virtual
	void PopCRDSets(i32u);			// virtual
	
	void CopyCRDSet(i32u, i32u);		// virtual
	void SwapCRDSets(i32u, i32u);		// virtual
	
	void CenterCRDSet(i32u);		// virtual
	void ReserveCRDSets(i32u);		// virtual
};

/*################################################################################################*/

#endif	// MM2MDL_H

// eof
