// QM1ENG9.CPP

// Copyright (C) 2000 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

/*################################################################################################*/

#include "qm1eng9.h"

/*################################################################################################*/

qm1_eng_hf1::qm1_eng_hf1(qm1_mdl & p1) : qm1_eng(p1)
{
	crd = new f64_a3[natm];
	grad = new f64_a3[natm];
}

qm1_eng_hf1::~qm1_eng_hf1(void)
{
	delete[] crd;
	delete[] grad;
}

const f64 * qm1_eng_hf1::GetCRD(i32u ind)
{
	return crd[ind];
}

void qm1_eng_hf1::PutCRD(i32u ind, const f64 * ref)
{
	for (i32u n1 = 0;n1 < 3;n1++)
	{
		crd[ind][n1] = ref[n1];
	}
}

void qm1_eng_hf1::Compute(i32s)
{
	energy = 0.0;
}

void qm1_eng_hf1::Check(i32s)
{
}

fGL qm1_eng_hf1::GetESP(fGL *, fGL * dd)
{
	if (dd != NULL)
	{
		dd[0] = 0.0;
		dd[1] = 0.0;
		dd[2] = 0.0;
	}
	
	return 0.0;
}

fGL qm1_eng_hf1::GetElDens(fGL *, fGL * dd)
{
	if (dd != NULL)
	{
		dd[0] = 0.0;
		dd[1] = 0.0;
		dd[2] = 0.0;
	}
	
	return 0.0;
}

fGL qm1_eng_hf1::GetOrbital(fGL *, fGL * dd)
{
	if (dd != NULL)
	{
		dd[0] = 0.0;
		dd[1] = 0.0;
		dd[2] = 0.0;
	}
	
	return 0.0;
}

fGL qm1_eng_hf1::GetOrbDens(fGL *, fGL * dd)
{
	if (dd != NULL)
	{
		dd[0] = 0.0;
		dd[1] = 0.0;
		dd[2] = 0.0;
	}
	
	return 0.0;
}

/*################################################################################################*/

// eof
