// T2MM2DOCV.CPP

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

/*################################################################################################*/

#include "t2mm2docv.h"

#include "mm2rbn.h"

#include "color.h"
#include "views.h"

#include "mm1mdl.h"

#include <fstream>
#include <strstream>

/*################################################################################################*/

glut_mm2_docv::glut_mm2_docv(view_factory & p1, ostream * p2, err_util_factory & p3, void * p4) :
	glut_docv(p1, p2, p3), mm2_docv(p1, p2, p3, p4), docview(p1, p2, p3), model_simple(p2, p3)
{
}

glut_mm2_docv::~glut_mm2_docv(void)
{
}

void glut_mm2_docv::KeyEvent(graphics_view * gv, char key, int, int)
{
	i32s t1a;
	
	ifstream ifile;
	ofstream ofile;
	
	smart_object * NewObject;
	
	switch (key)
	{
		case 'h':
		cout << "C         -> change color modes" << endl;
		cout << "r         -> change the rendering mode (without updating view)" << endl;
		cout << "O         -> open a file" << endl;
		cout << "S         -> save to a file" << endl;
		cout << "t         -> build a protein ribbon model" << endl;
		break;
		
		case 'C':
		if (gv->colormode == & mm2_docv::cm_state) gv->colormode = & mm2_docv::cm_residue;
		else if (gv->colormode == & mm2_docv::cm_residue) gv->colormode = & mm2_docv::cm_sasa;
		else if (gv->colormode == & mm2_docv::cm_sasa) gv->colormode = & mm2_docv::cm_state;
		UpdateAllGraphicsViews();
		break;
		
		case 'r':
		cout << "rendering = ";
		switch (gv->render)
		{
			case RENDER_NOTHING:
			gv->render = RENDER_WIREFRAME;
			cout << "RENDER_WIREFRAME";
			break;
			
			case RENDER_WIREFRAME:
			gv->render = RENDER_BALL_AND_STICK;
			cout << "RENDER_BALL_AND_STICK";
			break;
			
			case RENDER_BALL_AND_STICK:
			gv->render = RENDER_VAN_DER_WAALS;
			cout << "RENDER_VAN_DER_WAALS";
			break;
			
			case RENDER_VAN_DER_WAALS:
			gv->render = RENDER_ACCESSIBLE;
			cout << "RENDER_ACCESSIBLE";
			break;
			
			case RENDER_ACCESSIBLE:
			gv->render = RENDER_CYLINDERS;
			cout << "RENDER_CYLINDERS";
			break;
			
			case RENDER_CYLINDERS:
			gv->render = RENDER_NOTHING;
			cout << "RENDER_NOTHING";
			break;
		}
		cout << endl;
		break;
		
		case 'O':
		cout << "name of file to open ??? "; cin >> buffer;
		ifile.open(buffer, ios::in); ReadStream(ifile); ifile.close();
		UpdateAllGraphicsViews();
		break;
		
		case 'S':
		cout << "name of file to save ??? "; cin >> buffer;
		ofile.open(buffer, ios::out); WriteStream(ofile); ofile.close();
		break;
		
		case 't':
		for (t1a = 0;t1a < (i32s) chn_vector.size();t1a++)
		{
			NewObject = new mm2_ribbon(this, gv->colormode, t1a, 4);	// min. order is 2!!!
			AddObject(NewObject);
		}
		UpdateAllGraphicsViews();
		break;
		
		default:
		cout << "unknown command '" << key << "'" << endl;
	}
}

/*################################################################################################*/

// eof
