// T2QM2DOCV.CPP

// Copyright (C) 2000 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

/*################################################################################################*/

#include "t2qm2docv.h"

#include "plane.h"
#include "surface.h"

#include "color.h"
#include "views.h"

/*################################################################################################*/

glut_qm2_docv::glut_qm2_docv(view_factory & p1, ostream * p2, err_util_factory & p3) :
	glut_docv(p1, p2, p3), qm2_docv(p1, p2, p3), docview(p1, p2, p3), model_simple(p2, p3)
{
}

glut_qm2_docv::~glut_qm2_docv(void)
{
}

void glut_qm2_docv::KeyEvent(graphics_view * gv, char key, int, int)
{
	switch (key)
	{
		case 'h':
		cout << "+ -       -> change the element" << endl;
		break;
		
		case '+': ++el;
		cout << "element = " << el.GetAtomicNumber();
		cout << " " << el.GetSymbol() << endl;
		break;
		
		case '-': --el;
		cout << "element = " << el.GetAtomicNumber();
		cout << " " << el.GetSymbol() << endl;
		break;
	}
}

/*################################################################################################*/

// eof
