// T3DOCV.CPP

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

/*################################################################################################*/

#include "t3docv.h"
#include "t3main.h"

#include <strstream>

/*################################################################################################*/

gnome_docv::gnome_docv(view_factory & p1, ostream * p2, err_util_factory & p3) :
	docview(p1, p2, p3), model_simple(p2, p3)
{
}

gnome_docv::~gnome_docv(void)
{
}

void gnome_docv::event_SelectedObjectChanged(void)
{
	// here we just set the new selection information for all statusbars...
	
	for (i32u n1 = 0;n1 < gnome_mdi_app::app_vector.size();n1++)
	{
		char txtbuff[256];
		ostrstream str(txtbuff, sizeof(txtbuff));
		
		str << project_filename << "." << GetProjectFileNameExtension() << " : ";
		if (selected_object) str << "selected object = " << selected_object->GetObjectName() << "." << ends;
		else str << "no selected object." << ends;
		
		GtkWidget * sb = gnome_mdi_app::app_vector[n1].statusbar;
		i32u context_id = gnome_mdi_app::app_vector[n1].context_id;
		
		gtk_statusbar_pop(GTK_STATUSBAR(sb), context_id);
		gtk_statusbar_push(GTK_STATUSBAR(sb), context_id, txtbuff);
	}
}

char * gnome_docv::GetConfigString(GnomeMDIChild * child, gpointer)
{
	return g_strdup(child->name);
}

/*################################################################################################*/

// eof
