// T3DOCV.H : a GNOME "document/view"-style base class.

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

/*################################################################################################*/

#ifndef T3DOCV_H
#define T3DOCV_H

class gnome_docv;

/*################################################################################################*/

class graphics_view;		// views.h
class treelist_view;		// views.h
class view_factory;		// views.h

#include "docview.h"

#include <gtk/gtk.h>
#include <gnome.h>

#include <vector>

/*################################################################################################*/

/// This will contain GNOME-dependent aspects of the "##docview" class...

class gnome_docv : virtual public docview
{
	protected:
	
	GnomeMDIGenericChild * child;
	GtkWidget * popupmenu;
	
	friend class gnome_view_factory;
	
	friend class gnome_ogl_view;
	friend class gnome_treelist_view;
	
	friend class gnome_qm1_docv;
	friend class gnome_mm1_docv;
	friend class gnome_mm2_docv;
	
	friend class mm1_file_open_dialog;
	friend class mm1_file_save_dialog;

	public:
	
	gnome_docv(view_factory &, ostream *, err_util_factory &);
	virtual ~gnome_docv(void);
	
	void event_SelectedObjectChanged(void);		// virtual
	
	static char * GetConfigString(GnomeMDIChild * child, gpointer);
};

/*################################################################################################*/

#endif	// T3DOCV_H

// eof
