// T3MM2DOCV.H : a graphical user interface for mm2-models.

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

/*################################################################################################*/

#include "config.h"	// this is target-dependent...

#ifndef T3MM2DOCV_H
#define T3MM2DOCV_H

class gnome_mm2_docv;

/*################################################################################################*/

#include "t3docv.h"
#include "mm2docv.h"

#include "t3dialog.h"

#include <gnome.h>

/*################################################################################################*/

class mm2_file_open_dialog : public file_dialog
{
	private:
	
	static const char title[];
	static mm2_docv * docv;
	
	public:
	
	mm2_file_open_dialog(mm2_docv *);
	~mm2_file_open_dialog(void);
	
	bool OkEvent(const char *);	// virtual
	void CancelEvent(void);		// virtual
};

/*################################################################################################*/

class gnome_mm2_docv : public gnome_docv, public mm2_docv
{
	protected:

	static GnomeUIInfo file_submenu[];
	static GnomeUIInfo select_submenu[];
	
	static GnomeUIInfo viewscreate_submenu[];	// render/views
	static GnomeUIInfo views_submenu[];		// render
	static GnomeUIInfo lights_submenu[];		// render
	static GnomeUIInfo rendermode_style_radio[];
	static GnomeUIInfo rendermode_submenu[];	// render
	static GnomeUIInfo projection_radio[];
	static GnomeUIInfo projection_submenu[];	// render
	static GnomeUIInfo render_submenu[];
	
	static GnomeUIInfo objects_submenu[];
	
	static GnomeUIInfo popupmenu_info[];
	static GnomeUIInfo popupmenu_dummy[];		// for tearoff
	
	public:
	
	gnome_mm2_docv(view_factory &, ostream *, err_util_factory &, void *);
	~gnome_mm2_docv(void);
	
	// the mm2-dependent popup-menu callbacks are here...
	// the mm2-dependent popup-menu callbacks are here...
	// the mm2-dependent popup-menu callbacks are here...
	
	static void popup_FileClose(GtkWidget *, gpointer);
	
	static void popup_RModeWireFrame(GtkWidget *, gpointer);
	static void popup_RModeBallAndStick(GtkWidget *, gpointer);
	static void popup_RModeVanDerWaals(GtkWidget *, gpointer);
	static void popup_RModeAccessible(GtkWidget *, gpointer);
	static void popup_RModeCylinders(GtkWidget *, gpointer);
	static void popup_RModeNothing(GtkWidget *, gpointer);

	static void popup_ObjRibbon(GtkWidget *, gpointer);
};

/*################################################################################################*/

#endif	// T3MM2DOCV_H

// eof
