// T3VIEWS.CPP

// Copyright (C) 1999 Tommi Hassinen, Ville Heikkil.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

/*################################################################################################*/

#include "t3views.h"

#include "t3main.h"
#include "t3docv.h"
#include "utility.h"

#include "t3qm1docv.h"	// temporary !?!?!?!?
#include "t3mm1docv.h"	// temporary !?!?!?!?

#include <strstream>

#include <algorithm>
#include <gnome.h>

// how to properly close gnome mdi views!?!?!
// how to properly close gnome mdi views!?!?!
// how to properly close gnome mdi views!?!?!

// the gnome stuff is removed using a call to gnome_mdi_remove_view(). but when user closes
// the whole program or the whole model, system seems to call that automatically... of course
// we have to finally remove our own stuff using a call to docv->RemoveGraphicsView().

// so, at the moment it seems to work this way, but the implementation is quite scattered...

/*################################################################################################*/

gnome_view::gnome_view(gnome_docv * p1) : view()
{
	docv = p1;
}

gnome_view::~gnome_view(void)
{
}

docview * gnome_view::GetDV(void)
{
	return docv;
}

/*################################################################################################*/

vector<gnome_ogl_view *> gnome_ogl_view::ogl_vector;

gnome_ogl_view::gnome_ogl_view(gnome_docv * p1) : gnome_view(p1), ogl_view()
{
	ogl_vector.push_back(this);
	
	int attrlst[] =
	{
		GDK_GL_RGBA,
		GDK_GL_RED_SIZE, 1,
		GDK_GL_GREEN_SIZE, 1,
		GDK_GL_BLUE_SIZE, 1,
		GDK_GL_DEPTH_SIZE, 1,
		GDK_GL_DOUBLEBUFFER,
		GDK_GL_NONE
	};
	
	view_widget = gtk_gl_area_new(attrlst);
//	gtk_widget_set_usize(GTK_WIDGET(view_widget), 100, 100);
	gtk_widget_set_usize(GTK_WIDGET(view_widget), 400, 400);	// how to set DEFAULT sizes !?!?!?
	
	int events = GDK_EXPOSURE_MASK;
	events |= GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK;
	events |= GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK;
	
	gtk_widget_set_events(GTK_WIDGET(view_widget), events);

	gtk_signal_connect(GTK_OBJECT(view_widget),
		"realize", GTK_SIGNAL_FUNC(RealizeHandler), NULL);
	
	gtk_signal_connect(GTK_OBJECT(view_widget),
		"expose_event", GTK_SIGNAL_FUNC(ExposeHandler), NULL);
	
	gtk_signal_connect(GTK_OBJECT(view_widget),
		"motion_notify_event", GTK_SIGNAL_FUNC(MotionNotifyHandler), NULL);
	
	gtk_signal_connect(GTK_OBJECT(view_widget),
		"button_press_event", GTK_SIGNAL_FUNC(ButtonHandler), NULL);
	
	gtk_signal_connect(GTK_OBJECT(view_widget),
		"button_release_event", GTK_SIGNAL_FUNC(ButtonHandler), NULL);
		
	gtk_signal_connect(GTK_OBJECT(view_widget),
		"configure_event", GTK_SIGNAL_FUNC(ConfigureHandler), NULL);
		
	gtk_widget_show(GTK_WIDGET(view_widget));
}

gnome_ogl_view::~gnome_ogl_view(void)
{
	vector<gnome_ogl_view *>::iterator it1;
	it1 = find(ogl_vector.begin(), ogl_vector.end(), this);
	
	if (it1 != ogl_vector.end())
	{
		ogl_vector.erase(it1);
	}
	else
	{
		cout << "WARNING : unknown view_widget at ~gnome_ogl_view()!!!" << endl;
	}
}

void gnome_ogl_view::Update(bool directly)
{
	if (directly) ExposeEvent();
	else ExposeEvent();
	
	// here we update always directly. should emit an update request for indirect rendering!?!?!?
	// here we update always directly. should emit an update request for indirect rendering!?!?!?
	// here we update always directly. should emit an update request for indirect rendering!?!?!?
}

void gnome_ogl_view::SetTitle(const char * p1)
{
//	gtk_window_set_title(GTK_WINDOW(gtkwin), p1);			// how to set mdi titles?!?!?!?!
//	gnome_mdi_child_set_name(GNOME_MDI_CHILD(docv->child), p1);	// this will change the document name...
}

void gnome_ogl_view::SetCurrent(void)
{
	bool failed = !gtk_gl_area_make_current(GTK_GL_AREA(view_widget));
	if (failed) cout << "SetCurrent(): can't make_current!!!" << endl;
}

gnome_ogl_view * gnome_ogl_view::GetWindow(GtkWidget * widget)
{
	vector<gnome_ogl_view *>::iterator it1 = ogl_vector.begin();
	while (it1 != ogl_vector.end())
	{
		vector<gnome_ogl_view *>::iterator it2 = it1++;
		if ((* it2)->view_widget == widget) return (* it2);
	}
	
	// return NULL if the search failed...
	// return NULL if the search failed...
	// return NULL if the search failed...
	
	return NULL;
}

void gnome_ogl_view::RealizeHandler(GtkWidget * widget, gpointer)
{
	gnome_ogl_view * window = GetWindow(widget);
	if (!window) cout << "Unknown ID in RealizeHandler !!!" << endl;
	else window->InitGL();
}

gint gnome_ogl_view::ExposeHandler(GtkWidget * widget, GdkEventExpose *)
{
	gnome_ogl_view * window = GetWindow(widget);
	if (!window) cout << "Unknown ID in ExposeHandler !!!" << endl;
	else window->ExposeEvent();
	
	return FALSE;
}

gint gnome_ogl_view::ButtonHandler(GtkWidget * widget, GdkEventButton * eb)
{
	gnome_ogl_view * window = GetWindow(widget);
	if (!window) cout << "Unknown ID in ButtonHandler !!!" << endl;
	else
	{
		mouse_tool::button tmpb; i32s tmps1;
		switch (eb->button)
		{
			case 1:
			tmpb = mouse_tool::Left;
			tmps1 = GDK_BUTTON1_MASK;
			break;
			
			case 3:
			tmpb = mouse_tool::Right;
			tmps1 = GDK_BUTTON3_MASK;
			break;
			
			default:
			tmpb = mouse_tool::Middle;
			tmps1 = GDK_BUTTON2_MASK;
		}
		
		mouse_tool::state tmps2 = (eb->state & tmps1) ? mouse_tool::Up : mouse_tool::Down;
		
		graphics_view * gv = dynamic_cast<graphics_view *>(window);
		
		if (tmps2 == mouse_tool::Down)
		{
			if (button == mouse_tool::None)
			{
				if (tmpb == mouse_tool::Right)
				{
					// the popup menu is created here. pointer to the glarea widget
					// is given as "user_data", and it is also passed to the popup
					// hander callback function (instead of the original value).
					
					gnome_popup_menu_do_popup(GetWindow(widget)->docv->popupmenu,
						NULL, NULL, NULL, window->view_widget);
						
					return TRUE;
				}
				
				button = tmpb;
				
				shift_down = (eb->state & GDK_SHIFT_MASK) ? true : false;
				ctrl_down = (eb->state & GDK_CONTROL_MASK) ? true : false;
				
				state = mouse_tool::Down;
				
				if (gv != NULL) current_tool->ButtonEvent(gv, eb->x, eb->y);
			}
		}
		else
		{
			if (button == mouse_tool::Left && tmpb != mouse_tool::Left) return TRUE;
			if (button == mouse_tool::Middle && tmpb != mouse_tool::Middle) return TRUE;
			if (button == mouse_tool::Right && tmpb != mouse_tool::Right) return TRUE;
			
			state = mouse_tool::Up;
			
			if (gv != NULL) current_tool->ButtonEvent(gv, eb->x, eb->y);
			
			button = mouse_tool::None;
		}
	}
	
	return TRUE;
}

gint gnome_ogl_view::ConfigureHandler(GtkWidget * widget, GdkEventConfigure *)
{
	gnome_ogl_view * window = GetWindow(widget);
	if (!window) cout << "Unknown ID in ConfigureHandler !!!" << endl;
	else
	{
		window->SetCurrent();
		window->SetSize(widget->allocation.width, widget->allocation.height);
	}
	
	return TRUE;
}

gint gnome_ogl_view::MotionNotifyHandler(GtkWidget * widget, GdkEventMotion * event)
{
	int x; int y; GdkModifierType state;
	if (event->is_hint) gdk_window_get_pointer(event->window, & x, & y, & state);
	else { x = (int) event->x; y = (int) event->y; state = (GdkModifierType) event->state; }
	
	if (button != mouse_tool::None)
	{
		gnome_ogl_view * window = GetWindow(widget);
		if (!window) cout << "Unknown ID in MotionNotifyHandler !!!" << endl;
		graphics_view * gv = dynamic_cast<graphics_view *>(window);
		
		if (gv != NULL) current_tool->MotionEvent(gv, x, y);
	}
	
	return TRUE;
}


/*################################################################################################*/

gnome_graphics_view::gnome_graphics_view(gnome_docv * p1, camera * p2) :
	gnome_ogl_view(p1), graphics_view(p2), ogl_view()
{
}

gnome_graphics_view::~gnome_graphics_view(void)
{
}

/*##############################################*/
/*##############################################*/

// the model-independent popup-menu callbacks are here...
// the model-independent popup-menu callbacks are here...
// the model-independent popup-menu callbacks are here...

void gnome_graphics_view::popup_SelectAll(GtkWidget *, gpointer data)
{
	GetGV((GtkWidget *) data)->docv->SelectAll();
}

void gnome_graphics_view::popup_InvertSelection(GtkWidget *, gpointer data)
{
	GetGV((GtkWidget *) data)->docv->InvertSelection();
}

void gnome_graphics_view::popup_ProjOrthographic(GtkWidget *, gpointer data)
{
	gnome_graphics_view * gv = GetGV((GtkWidget *) data);
	gv->cam->ortho = true; gv->docv->UpdateGraphicsViews(gv->cam);
}

void gnome_graphics_view::popup_ProjPerspective(GtkWidget *, gpointer data)
{
	gnome_graphics_view * gv = GetGV((GtkWidget *) data);
	gv->cam->ortho = false; gv->docv->UpdateGraphicsViews(gv->cam);
}

void gnome_graphics_view::popup_RenderQuickUpdate(GtkWidget *, gpointer data)
{
	gnome_graphics_view * gv = GetGV((GtkWidget *) data);
	gv->quick_update = !gv->quick_update;
}

void gnome_graphics_view::popup_ViewsNewCam(GtkWidget *, gpointer data)
{
	gnome_graphics_view * gv = GetGV((GtkWidget *) data);
	gv->docv->AddGraphicsView();
}

void gnome_graphics_view::popup_ViewsNewView(GtkWidget *, gpointer data)
{
	gnome_graphics_view * gv = GetGV((GtkWidget *) data);
	gv->docv->AddGraphicsView(gv->cam);
}

void gnome_graphics_view::popup_ViewsDeleteView(GtkWidget *, gpointer data)
{
	gnome_graphics_view * gv = GetGV((GtkWidget *) data);
	gnome_mdi_remove_view(gnome_mdi_app::mdi, gv->view_widget, TRUE);	// remove the system stuff...
	gv->docv->RemoveGraphicsView(gv);					// then remove the rest...
}

void gnome_graphics_view::popup_LightsNewLight(GtkWidget *, gpointer data)
{
	gnome_graphics_view * gv = GetGV((GtkWidget *) data);
	
	char input; light * new_light;
	
	cout << "add light:" << endl;
	cout << "directional- or spotlight ? (d/s) "; cin >> input;
	
	if (input == 'd') new_light = new directional_light(ol_static());
	else if (input == 's')
	{
		new_light = new spot_light(ol_static());
		
		const fGL trans[3] = { 0.0, 0.0, -1.0 };
		new_light->TranslateObject((const fGL *) trans, gv->cam->GetLocData());
	}
	else return;
	
	cout << "global or local light ? (g/l) "; cin >> input;
	
	if (input == 'g') gv->docv->AddGlobalLight(new_light);
	else if (input == 'l') gv->docv->AddLocalLight(new_light, gv->cam);
	else delete new_light;
	
	if (input == 'g' || graphics_view::draw_info) gv->docv->UpdateAllGraphicsViews();
	else if (input == 'l') gv->docv->UpdateGraphicsViews(gv->cam);
}

void gnome_graphics_view::popup_LightsSwitchLoc(GtkWidget *, gpointer data)
{
	gnome_graphics_view * gv = GetGV((GtkWidget *) data);
	gv->docv->DoSwitchLocalLights(gv->cam, false);
}

void gnome_graphics_view::popup_LightsSwitchGlob(GtkWidget *, gpointer data)
{
	gnome_graphics_view * gv = GetGV((GtkWidget *) data);
	gv->docv->DoSwitchLocalLights(gv->cam, false);
}

void gnome_graphics_view::popup_ObjectsDeleteCurrent(GtkWidget *, gpointer data)
{
	gnome_graphics_view * gv = GetGV((GtkWidget *) data);
	gv->docv->DoDeleteCurrentObject();
}

/*##############################################*/
/*##############################################*/

gnome_graphics_view * gnome_graphics_view::GetGV(GtkWidget * widget)
{
	gnome_ogl_view * window = gnome_ogl_view::GetWindow(widget);
	if (!window) cout << "Unknown ID in gnome_graphics_view::GetGV() !!!" << endl;
	
	gnome_graphics_view * gv = dynamic_cast<gnome_graphics_view *>(window);
	if (gv != NULL) return gv;
	else
	{
		cout << "bad cast in gnome_graphics_view::GetGV() !!!!!" << endl;
		return NULL;
	}
}

void gnome_graphics_view::ExposeEvent(void)
{
	SetCurrent(); Render(); glFlush();
//	gtk_gl_area_swap_buffers(GTK_GL_AREA(view_widget));		// newer way???
	gtk_gl_area_swapbuffers(GTK_GL_AREA(view_widget));		// older way???
}

/*################################################################################################*/

vector<gnome_treelist_view *> gnome_treelist_view::tl_vector;

gnome_treelist_view::gnome_treelist_view(gnome_docv * p1) : gnome_view(p1), treelist_view()
{
	tl_vector.push_back(this);
	
	view_widget = GTK_WIDGET(gtk_hpaned_new());
	
	gtk_widget_set_usize(GTK_WIDGET(view_widget), 400, 400);	// how to set DEFAULT sizes !?!?!?
	
	tree = GTK_WIDGET(gtk_tree_new());
	gtk_widget_set_usize(GTK_WIDGET(tree), 100, 100);
	
	// initialize...
	// initialize...
	// initialize...
	
	// is there a bug in gtk_tree?!?!??!?!
	// it seems to lose those expand-buttons when we drag/drop a view in MDI "notebook" mode...
	
	// when we remove the last item from a subtree, it seems that the subtree is automatically deleted.
	// so, we have to create a new subtree always when we add the first item.
	
	item_lights = gtk_tree_item_new_with_label("Lights");
	gtk_widget_show(item_lights); gtk_tree_append(GTK_TREE(tree), item_lights);
	
	for (i32u n1 = 0;n1 < docv->light_vector.size();n1++)
	{
		LightAdded(docv->light_vector[n1]);
	}
	
	item_objects = gtk_tree_item_new_with_label("Objects");
	gtk_widget_show(item_objects); gtk_tree_append(GTK_TREE(tree), item_objects);
	
	for (i32u n1 = 0;n1 < docv->object_vector.size();n1++)
	{
		ObjectAdded(docv->object_vector[n1]);
	}
	
	// ready...
	// ready...
	// ready...
	
	gtk_widget_show(tree);
	
	list = gtk_label_new("TODO : a list view!");
	gtk_widget_set_usize(GTK_WIDGET(list), 100, 100);
	gtk_widget_show(list);
	
	gtk_paned_add1(GTK_PANED(view_widget), GTK_WIDGET(tree));
	gtk_paned_add2(GTK_PANED(view_widget), GTK_WIDGET(list));
	
	gtk_widget_show(GTK_WIDGET(view_widget));
}

gnome_treelist_view::~gnome_treelist_view(void)
{
	vector<gnome_treelist_view *>::iterator it1;
	it1 = find(tl_vector.begin(), tl_vector.end(), this);
	
	if (it1 != tl_vector.end())
	{
		tl_vector.erase(it1);
	}
	else
	{
		cout << "WARNING : unknown view_widget at ~gnome_treelist_view()!!!" << endl;
	}
}

void gnome_treelist_view::Update(bool directly)
{
	cout << "gnome_treelist_view::Update() called with param " << directly << endl;
// how to handle update requests!??!?!
// how to handle update requests!??!?!
// how to handle update requests!??!?!
}

void gnome_treelist_view::SetTitle(const char * p1)
{
//	gtk_window_set_title(GTK_WINDOW(gtkwin), p1);			// how to set mdi titles?!?!?!?!
//	gnome_mdi_child_set_name(GNOME_MDI_CHILD(docv->child), p1);	// this will change the document name...
}

void gnome_treelist_view::LightAdded(light * p1)
{
	gnome_tlv_light_record nrec; nrec.ref = p1;
	
	char buffer[256];
	ostrstream str(buffer, sizeof(buffer));
	str << p1->GetObjectName() << " ";
	
	// here we have to search for the camera number, which is a bit inconvenient...
	// "index" also for objects (like atoms, etc...) ?!?!? how to keep track of it???
	
	if (!p1->owner) str << "[global]" << ends;
	else
	{
		i32u index = 0;
		while (index < docv->camera_vector.size())
		{
			if (docv->camera_vector[index] != p1->owner) index++;
			else break;
		}
		
		str << "[cam " << (index + 1) << "]" << ends;
	}
	
	nrec.item = gtk_tree_item_new_with_label(buffer);
	gtk_widget_show(nrec.item);
	
	if (light_vector.empty())	// create a new subtree, if needed...
	{
		subt_lights = GTK_WIDGET(gtk_tree_new());
		gtk_tree_item_set_subtree(GTK_TREE_ITEM(item_lights), subt_lights);
		gtk_signal_connect(GTK_OBJECT(subt_lights), "select_child", GTK_SIGNAL_FUNC(SelectChildHandler), tree);
	}
	
	gtk_tree_append(GTK_TREE(subt_lights), nrec.item);
	light_vector.push_back(nrec);
}

void gnome_treelist_view::LightRemoved(light * p1)
{
	i32u index = 0;
	while (index < light_vector.size())
	{
		if (light_vector[index].ref != p1) index++;
		else
		{
			gtk_tree_remove_item(GTK_TREE(subt_lights), light_vector[index].item);
			light_vector.erase(light_vector.begin() + index);
			return;
		}
	}
	
	cout << "tried to remove an unknown light!!!" << endl;
}

void gnome_treelist_view::ObjectAdded(smart_object * p1)
{
	gnome_tlv_object_record nrec; nrec.ref = p1;
	
	nrec.item = gtk_tree_item_new_with_label(p1->GetObjectName());
	gtk_widget_show(nrec.item);
	
	if (object_vector.empty())	// create a new subtree, if needed...
	{
		subt_objects = GTK_WIDGET(gtk_tree_new());
		gtk_tree_item_set_subtree(GTK_TREE_ITEM(item_objects), subt_objects);
		gtk_signal_connect(GTK_OBJECT(subt_objects), "select_child", GTK_SIGNAL_FUNC(SelectChildHandler), tree);
	}
	
	gtk_tree_append(GTK_TREE(subt_objects), nrec.item);
	object_vector.push_back(nrec);
}

void gnome_treelist_view::ObjectRemoved(smart_object * p1)
{
	i32u index = 0;
	while (index < object_vector.size())
	{
		if (object_vector[index].ref != p1) index++;
		else
		{
			gtk_tree_remove_item(GTK_TREE(subt_objects), object_vector[index].item);
			object_vector.erase(object_vector.begin() + index);
			return;
		}
	}
	
	cout << "tried to remove an unknown object!!!" << endl;
}

void gnome_treelist_view::SelectChildHandler(GtkTree * subt, GtkWidget * item, gpointer data)
{
	i32u index = 0;
	while (index < tl_vector.size())
	{
		if (tl_vector[index]->tree != data) index++;
		else return tl_vector[index]->SelectChildEvent(subt, item);
	}
	
	cout << "unknown root found at gnome_treelist_view::SelectChildHandler()!" << endl;
}

void gnome_treelist_view::SelectChildEvent(GtkTree * subt, GtkWidget * item)
{
	if (subt == GTK_TREE(subt_lights))
	{
		i32u index = 0;
		while (index < light_vector.size())
		{
			if (light_vector[index].item != item) index++;
			else
			{
				cout << "treelist: selected light ";
				cout << light_vector[index].ref->GetObjectName() << endl;
				
				docv->SelectLight(light_vector[index].ref);
				return;
			}
		}
	}
	
	if (subt == GTK_TREE(subt_objects))
	{
		i32u index = 0;
		while (index < object_vector.size())
		{
			if (object_vector[index].item != item) index++;
			else
			{
				cout << "treelist: selected object ";
				cout << object_vector[index].ref->GetObjectName() << endl;
				
				docv->SelectObject(object_vector[index].ref);
				return;
			}
		}
	}
}

/*################################################################################################*/

gnome_view_factory * gnome_view_factory::instance = NULL;
singleton_cleaner<gnome_view_factory> gnome_view_factory_cleaner(gnome_view_factory::GetInstance());

i32s gnome_view_factory::view_type = VIEWTYPE_DEFAULT;

camera * gnome_view_factory::last_cam = NULL;
gnome_graphics_view * gnome_view_factory::last_gv = NULL;
gnome_treelist_view * gnome_view_factory::last_tlv = NULL;

gnome_view_factory::gnome_view_factory(void) : view_factory()
{
}

gnome_view_factory::~gnome_view_factory(void)
{
}

gnome_view_factory * gnome_view_factory::GetInstance(void)
{
	if (instance != NULL) return instance;
	else return (instance = new gnome_view_factory());
}

// we could set gnome_mdi_restore_state call this...
// here we should then pick up the correct model type (based on the string),
// and create it, without calling gnome_mdi_add_child.

// we should set an extra parameter, bool=true, at gnome_docv ctors??!?!?
// we should set an extra parameter, bool=true, at gnome_docv ctors??!?!?
// we should set an extra parameter, bool=true, at gnome_docv ctors??!?!?

//GnomeMDIChild * gnome_view_factory::ChildCreator(const char *)
//{
//cout << "gnome_view_factory::ChildCreator() was called!!!" << endl;
//	return NULL;
//}

// this will produce a graphics_view-objects for GNOME !?!?!?!?
// do we need this at all until we try to use sesson saving etc??!?!?
// do we need this at all until we try to use sesson saving etc??!?!?
// do we need this at all until we try to use sesson saving etc??!?!?

// view_type will be VIEWTYPE_DEFAULT if the system calls this...

GtkWidget * gnome_view_factory::ViewCreator(GnomeMDIChild * child, gpointer)
{
	docview * docv1 = (docview *) gtk_object_get_user_data(GTK_OBJECT(child));
	gnome_docv * docv2 = dynamic_cast<gnome_docv *>(docv1);
	
	if (!docv2)
	{
		cout << "bad cast at gnome_view_factory::ViewCreator()!!!" << endl;
		return NULL;
	}
	
	switch (view_type)
	{
		case VIEWTYPE_DEFAULT:
cout << "gnome_view_factory::ViewCreator() was called with VIEWTYPE_DEFAULT!!!" << endl;
		
		// if the system calls this on it's own, there will be no valid camera.
		// it this is the case, then we just create one, and add it to the docv...
		
		if (!last_cam)
		{
			// hummm... we have to change "AddCamera" logic a bit...
			// hummm... we have to change "AddCamera" logic a bit...
			// hummm... we have to change "AddCamera" logic a bit...
			
			cout << "oops, we have no valid camera at gnome_view_factory::ViewCreator() !!!" << endl;
			
			//last_cam = new camera();
		}
		
		case VIEWTYPE_GRAPHICS:
		last_gv = new gnome_graphics_view(docv2, last_cam);
		return last_gv->view_widget;

		case VIEWTYPE_TREELIST:
		last_tlv = new gnome_treelist_view(docv2);
		return last_tlv->view_widget;
		
		default:
		cout << "unknown view type " << view_type << " at gnome_view_factory::ViewCreator()" << endl;
		exit(EXIT_FAILURE);
		return NULL;
	}
}

// gnome API says that all views must be added using a call to gnome_mdi_add_view, so we have
// little choice here... first we just set the view type, and then call gnome_mdi_add_view.

graphics_view * gnome_view_factory::ProduceGraphicsView(docview * docv1, camera * cam)
{
	gnome_docv * docv2 = dynamic_cast<gnome_docv *>(docv1);
	
	view_type = VIEWTYPE_GRAPHICS; last_cam = cam;
	gnome_mdi_add_view(gnome_mdi_app::GetInstance()->mdi, GNOME_MDI_CHILD(docv2->child));
	view_type = VIEWTYPE_DEFAULT; last_cam = NULL; return last_gv;
}

treelist_view * gnome_view_factory::ProduceTreeListView(docview * docv1)
{
	gnome_docv * docv2 = dynamic_cast<gnome_docv *>(docv1);
	
	view_type = VIEWTYPE_TREELIST;
	gnome_mdi_add_view(gnome_mdi_app::GetInstance()->mdi, GNOME_MDI_CHILD(docv2->child));
	view_type = VIEWTYPE_DEFAULT; return last_tlv;
}

/*################################################################################################*/

// eof
